--- a/plugins/cinterion/mm-broadband-bearer-cinterion.c	2022-07-14 23:18:10.476517403 +0200
+++ b/plugins/cinterion/mm-broadband-bearer-cinterion.c	2022-07-14 23:19:07.321517885 +0200
@@ -556,6 +556,12 @@
     gboolean                 ip_cs;
 } ConMonContext;
 
+typedef struct {
+    guint                    cid;
+    guint                    usbicindex;
+    guint                    chkattempt;
+} SwwanCheckContext;
+
 #define CINT_SPECIAL_HARD_RESET_STATUS ((int)-1)
 
 gint cint_str_count (const char *str, char c)
@@ -963,7 +969,7 @@
                 /* <GwAddr> */
                 if (token[0] == '"') token += 1;
                 if (token[strlen(token)-1] == '"') token[strlen(token)-1] = '\0';
-                if (inet_aton(token, &ctx->gateway_addr) == 0) mm_obj_err(self, "%s: could not convert gwa=%s", __func__, token);
+                if (inet_aton(token, &ctx->gateway_addr) == 0) mm_obj_dbg(self, "%s: could not convert gwa=%s", __func__, token);
                 /* that's all we need */
                 break;
             }
@@ -1035,12 +1041,12 @@
     const gchar                *response;
     GError                     *error = NULL;
     MMBearerConnectionStatus    status;
-    guint                       cid;
+    SwwanCheckContext          *scctx;
     ConMonContext              *ctx;
     char                       scan_str[32];
 
     self = g_task_get_source_object (task);
-    cid = GPOINTER_TO_UINT (g_task_get_task_data (task));
+    scctx = g_task_get_task_data (task);
 
     response = mm_base_modem_at_command_finish (modem, res, &error);
     if (!response) {
@@ -1049,12 +1055,29 @@
         return;
     }
 
-    status = mm_cinterion_parse_swwan_response (response, cid, self, &error);
+    status = mm_cinterion_parse_swwan_response (response, scctx->cid, self, &error);
     if (status == MM_BEARER_CONNECTION_STATUS_UNKNOWN) {
         g_task_return_error (task, error);
         g_object_unref (task);
         return;
     }
+    /* ELS62 SWWAN activation seems to fail Workaround */
+    if ((scctx->usbicindex < (sizeof(usb_interface_configs) / sizeof(UsbInterfaceConfig))) &&
+        (usb_interface_configs[scctx->usbicindex].swwan_index == 1) &&
+        (usb_interface_configs[scctx->usbicindex].usb_iface_num == 0x08) &&
+        (status == MM_BEARER_CONNECTION_STATUS_DISCONNECTED) &&
+        (scctx->chkattempt < 10)) {
+	scctx->chkattempt += 1;
+        mm_obj_info (self, "%s: SWWAN(usb0) activation seemed to fail, wait and try again (attempt: %d)", __func__, scctx->chkattempt);
+	sleep(scctx->chkattempt/2 + 1);
+        mm_base_modem_at_command (modem,
+                                  "^SWWAN?",
+                                  5,
+                                  FALSE,
+                                  (GAsyncReadyCallback) swwan_check_status_ready,
+                                  task);
+        return;
+    }
 
     /* store the later to be returned WWAN connection status in a new connection monitor context */
     ctx = g_new0 (ConMonContext, 1);
@@ -1063,7 +1086,7 @@
     g_task_set_task_data (task, ctx, g_free);
 
     memset(scan_str, 0, sizeof(scan_str));
-    sprintf(scan_str, "^SWWAN: %1d, %1d,   ", cid, (status == MM_BEARER_CONNECTION_STATUS_CONNECTED) ? 1 : 0);
+    sprintf(scan_str, "^SWWAN: %1d, %1d,   ", scctx->cid, (status == MM_BEARER_CONNECTION_STATUS_CONNECTED) ? 1 : 0);
     scan_str[strlen(scan_str)-2] = '%'; scan_str[strlen(scan_str)-1] = 'd';
     if (sscanf(response, scan_str, &ctx->wwan_adap_id) != 1) {
         /* WWAN adapter not mentioned, assume 1 */
@@ -1081,14 +1104,21 @@
 static void
 load_connection_status_by_cid (MMBroadbandBearerCinterion *bearer,
                                guint                       cid,
+                               guint                       usbicindex,
                                GAsyncReadyCallback         callback,
                                gpointer                    user_data)
 {
-    GTask       *task;
-    MMBaseModem *modem;
+    GTask             *task;
+    MMBaseModem       *modem;
+    SwwanCheckContext *ctx;
 
     task = g_task_new (bearer, NULL, callback, user_data);
-    g_task_set_task_data (task, GUINT_TO_POINTER (cid), NULL);
+
+    ctx = g_new0 (SwwanCheckContext, 1);
+    g_assert(ctx != NULL);
+    ctx->cid = cid;
+    ctx->usbicindex = usbicindex;
+    g_task_set_task_data (task, ctx, g_free);
 
     g_object_get (bearer,
                   MM_BASE_BEARER_MODEM, &modem,
@@ -1108,8 +1138,12 @@
                         GAsyncReadyCallback  callback,
                         gpointer             user_data)
 {
+    /* ELS62 Workaround not to be considered in this case (only when setting up the connection) */
+    guint usbicindex = (sizeof(usb_interface_configs) / sizeof(UsbInterfaceConfig)) + 1;
+
     load_connection_status_by_cid (MM_BROADBAND_BEARER_CINTERION (bearer),
                                    mm_broadband_bearer_get_3gpp_cid (MM_BROADBAND_BEARER (bearer)),
+                                   usbicindex,
                                    callback,
                                    user_data);
 }
@@ -1437,6 +1471,7 @@
                     ctx->step, DIAL_3GPP_CONTEXT_STEP_LAST, usb_interface_configs[ctx->usb_interface_config_index].swwan_index);
         load_connection_status_by_cid (ctx->self,
                                        ctx->cid,
+                                       ctx->usb_interface_config_index,
                                        (GAsyncReadyCallback) dial_connection_status_ready,
                                        task);
         return;
@@ -1635,6 +1670,7 @@
                     usb_interface_configs[ctx->usb_interface_config_index].swwan_index);
         load_connection_status_by_cid (MM_BROADBAND_BEARER_CINTERION (ctx->self),
                                        ctx->cid,
+                                       ctx->usb_interface_config_index + 1, /* ELS62 Workaround not to be considered */
                                        (GAsyncReadyCallback) disconnect_connection_status_ready,
                                        task);
          return;
